#pragma once

#include <string>

#include <cppmariadb/config.h>
#include <cppmariadb/enums.h>

namespace cppmariadb
{

    struct column
    {
        std::string     name;           //!< Name of the column.
        std::string     original_name;  //!< Original name of the column (if not renamed)
        std::string     table;          //!< Name of the table.
        std::string     original_table; //!< Original name of the table (if not renamed)
        std::string     database;       //!< Name of the database.
        unsigned long   length;         //!< Length of the column.
        unsigned long   max_length;     //!< Maximal length of the column.
        column_flags    flags;          //!< Column flags.
        unsigned int    decimals;       //!< Decimals
        unsigned int    charset_number; //!< Cahrset numbers.
        column_type     type;           //!< Column type.

        /**
         * @brief Value constructor. Create a column object from the mariadb fields handle.
         */
        inline column(MYSQL_FIELD& f);
    };

}
