#include <cppmariadb/result.h>

#include <cppmariadb/row.inl>
#include <cppmariadb/result.inl>
#include <cppmariadb/impl/handle.inl>

using namespace ::cppmariadb;

/* result */

result::~result()
    { free(); }

row* result::next()
{
    if (_is_initialized && !_row)
        return nullptr;

    _is_initialized = true;
    auto r = mysql_fetch_row(get_handle());
    if (r)
    {
        _row.reset(new row(*this, r));
        ++_rowindex;
    }
    else
        _row.reset();

    return _row.get();
}

void result::update_columns() const
{
    auto f = mysql_fetch_fields(get_handle());
    auto c = mysql_num_fields  (get_handle());
    _columns.clear();
    _columns.reserve(c);
    for (size_t i = 0; i < c; ++i)
        _columns.emplace_back(f[i]);
}

/* result_used */

result_used::~result_used()
    { while(next()); /* fetch rows until none is left */ }
